/*
 * Warzone code
 *
 * Lars
 * Mar 2001
 */

#include "conf.h"
#include "sysdep.h"
 
#include "structs.h"
#include "buffer.h"
#include "db.h"
#include "utils.h"
#include "handler.h"
#include "comm.h"
#include "clan.h"
#include "warzone.h"


/* External stuff */
extern struct zone_data *zone_table;
extern struct descriptor_data *descriptor_list;
extern struct room_data *world;
extern struct index_data *mob_index;
extern struct char_data *character_list;
extern struct clan_info *clan_index;
void reset_zone(zone_rnum zone);

/* Internal Stuff */
int value = FALSE;

void warzone_update(void)
{
  int num1 = 0, num2 = 0;

  if ((num1 = num_in_castleone()) > 0) {
  }

  if ((num2 = num_in_castletwo()) > 0) {
  }
}

int warzone_reset(struct descriptor_data *d, int castle, zone_rnum i)
{
  reset_zone(i);
  sprintf(buf, "Zone %d has been reset!", i);
  mudlog(buf, NRM, LVL_LSIMMORT, TRUE);

  if (castle == 1) {
    sprintf(buf, "Castle one has been captured!");
    infolog(buf);
  }
  if (castle == 2) {
    sprintf(buf, "Castle two has been captured!");
    infolog(buf);
  }

  return (0);
}

int num_in_castleone()
{
  register struct descriptor_data *d;
  register struct descriptor_data *d_last;
  int num = 0;
  zone_rnum i;

  for (d = descriptor_list; d; d = d->next) {
    if (STATE(d) == CON_PLAYING) {
      if (zone_table[world[d->character->in_room].zone].number == WZ_ZONE && GET_ROOM_VNUM(IN_ROOM(d->character)) >= CASTLEONE_BOTTOM &&
                GET_ROOM_VNUM(IN_ROOM(d->character)) <= CASTLEONE_TOP) {
	i = world[d->character->in_room].zone;
	d_last = d;
        if (PLAYERCLAN(d->character) != PLAYERCLAN(d_last->character))
	  return (0);
	if ((CLANRANK(d->character) > 0) && (mobs_in_castleone() == 0)) {
          num++;
	  warzone_reset(d, 1, i);
	  CLANTOTRANK(clan_index[PLAYERCLAN(d->character)]) += 10000;
	  return (0);
	}
      }
    }
  }

  return (num);
}

int mobs_in_castleone()
{
  register struct char_data *i;
  int mob = 0;

  for (i = character_list; i; i = i->next)
    if (IS_NPC(i) && GET_ROOM_VNUM(IN_ROOM(i)) >= 20069 && GET_ROOM_VNUM(IN_ROOM(i)) <= 20090)
      mob++;

  return (mob);
}

int num_in_castletwo()
{
  struct descriptor_data *d;
  struct descriptor_data *d_last;
  int num = 0;
  zone_rnum i = 0;
 
  for (d = descriptor_list; d; d = d->next) {
    if (STATE(d) == CON_PLAYING) {
      if (zone_table[world[d->character->in_room].zone].number == WZ_ZONE && GET_ROOM_VNUM(IN_ROOM(d->character)) >= CASTLETWO_BOTTOM &&
                GET_ROOM_VNUM(IN_ROOM(d->character)) <= CASTLETWO_TOP) { 
        i = world[d->character->in_room].zone;
	d_last = d;
        if (PLAYERCLAN(d->character) != PLAYERCLAN(d_last->character))
	  return (0);
        if ((CLANRANK(d->character) > 0) && (mobs_in_castleone() == 0)) {
          num++;
          warzone_reset(d, 1, i);
          CLANTOTRANK(clan_index[PLAYERCLAN(d->character)]) += 10000;
          return (0);
        }
      }
    }
  }

  return (num);
}

int mobs_in_castletwo()
{
  register struct char_data *i;
  int mob = 0;
 
  for (i = character_list; i; i = i->next)
    if (IS_NPC(i) && GET_ROOM_VNUM(IN_ROOM(i)) >= 20091 && GET_ROOM_VNUM(IN_ROOM(i)) <= 20127)
      mob++;
 
  return (mob);
}
